import random
import numpy as np
from matplotlib import pyplot as plt

slovnik = {}

def najdi_praotce(dite):
    return ...

def nastav_otce(otec, dite):
    slovnik[najdi_praotce(dite)] = najdi_praotce(otec)

def vsechny_hrany(sirka, vyska):
    hrany = []
    ...
    return hrany

def nakresli_caru(pole, odkud, kam, n=2):
    x1, y1 = odkud
    x2, y2 = kam
    pole[2*y1, 2*x1] = 1  # zatím jsme nakreslili jen počáteční bod

def bludiste(sirka, vyska):
    hrany = vsechny_hrany(sirka, vyska)
    random.shuffle(hrany)
    pole = np.zeros((2*vyska-1, 2*sirka-1))
    for a, b in hrany:
        if najdi_praotce(a) != najdi_praotce(b):
            nakresli_caru(pole, a, b)
            nastav_otce(a, b)
            assert(najdi_praotce(a) == najdi_praotce(b))
    return pole

pole = bludiste(5, 5)
# až vyzkoušíte, že vám funguje `nakresli_caru`, tak tyhle příkazy smažte
nakresli_caru(pole, (0, 0), (0, 4))
nakresli_caru(pole, (0, 4), (4, 4))
plt.imshow(pole, cmap='gray')
plt.show()
